#include "dwedit.inc"


tTitle:						;Label qui permet  ION d'extraire du programme son nom.
							;L'utilisation de "tTitle" et "lblstart" est impose par DWEDIT.inc
							;(voir ce dernier pour plus d'informations).
 .db    "tests inputxt",0	;Explication : 0 indique  plusieurs ROM_CALLS comme "vputs" la fin
 							;de la chane de caractres.

;Dbut du programme.

lblstart:

	bcall(_CLRLCDFULL)
 ld hl,$0000
 ld (pencol),hl
 ld hl,enonce
	bcall(_vputs)
 ld hl,$0F00
 ld (pencol),hl
 ld hl,enonce2
	bcall(_vputs)
 ld de,saferam3
 ld hl,$0001
 ld (currow),hl
 ld c,14
 call inputxt

	bcall(_CLRLCDFULL)
 ld hl,$0303
 ld (currow),hl
 ld hl,saferam3+1	;Un 0 est stock avant le dbut de la chane de caractres ( saferam3 ici).
	bcall(_puts)
 call waitkey
 ret

enonce:
 .db "Entrez des caracteres :",0
enonce2:
 .db "2nd : valider DEL : effacer",0




;
;inputxt par Joe14 (MYP).												
;Version : 1.0															
;Date d'achvement : 05/03/2007  23h24									
;Taille :  ~102 octets													
;Plates-formes : TI 82, 83, 83 PLUS [SE], 84, 84 Plus					
;Edit  l'aide de Crimson editor v. 3.7								
;Merci  David de Cirrus programming pour ses syntaxfiles trs pratiques
;

;entre de : adresse RAM o doit dbuter l'enregistrement du texte.
;on enregistre $00 dans la premire case mmoire et dans la dernire.
;il faut donc prvoir deux adresses en plus.
;entres curcol et currow
;entre c : nombre de caractres MAX compris dans ]0;16]
;Registres dtruits : de, hl, bc, af.
;Valeurs de sortie :
;a = 0
;f = %01?0?000
;b = ?
;c = nombre de lettres MAX - nombre de lettres rel.
;de = adresse du dernier zro.
;h = ? (getcsc...)
;l = code getcsc de dernire touche appuye.

inputxt:
 xor a				;Met le contenu de l'accumulateur  zro.
itxtnodel1:
 ld (de),a			;Cre le repre de dbut de ligne (c'est--dire, un zro).
itxtnodel:
 inc de				;Passe  l'adresse suivante.
itxtcapture:
 xor a				;Met le contenu de l'accumulateur  zro.
 ld (de),a			;Copie de zro  l'adresse indique par de.
 call waitkey		;Retourne le code de la touche presse dans l'accumulateur.
 ld l,a				;Sauvegarde le code touche obtenu.
 sub $36			;Compare ce dernier  celui correspondant  la touche "2nd".
 ret z				;Si bouton "2nd" press, fin de routine.
 sub $38-$36		;Comparaison avec le code li  la touche "DEL".
 jr z,itxtdel		;Si la touche presse est bien "DEL", va au label correcpondant.
 xor a				;Met le contenu de l'accumulateur  zro.
 cp c				;Regarde si le nombre de caractres maximum spcifi est atteint.
 jr z,itxtcapture+1	;Si c'est le cas, saute au label idoine.

itxtdetermination:	;Sinon, on analyse le code de la touche renvoy par la routine waitkey.
 ld h,a				;Met h  zro.
 ld b,a				;Met b  zro.
 ld a,$21			;Charge le code (getcsc) de la touche 0 lie  l'espace.
 sub l				;Compare ce code  celui entr par l'utilisateur (et soustrait le contenu de l  a).
 jr z,itxtcodelettre;Si cela correspond, va au label itxtcodelettre (ce caractre n'est pas intgr  la boucle de dtection).
 ld l,5				;Prpare une boucle  venir.
 sub 17				;Prpare une comparaison  venir.
 call itxtadd31		;Appelle la fonction de comparaison (note : b = 0).
 sub 16				;Prpare une comparaison  venir.
itxtboucle:			;Dbut de la boucle de comparaison.
 ld b,2				;Charge la valeur ncessaire  la boucle djnz incluse dans itxtadd31.
 call itxtadd31		;Appelle la fonction de comparaison (note : b = 2).
 jr nz,itxtboucle	;Relance la comparaison.
 push af			;Met une valeur dans la pile, car le "ret p" qu'on trouve
					;plus loin ne sera pas utilis, mais le "pop af" sera lui excut.
 
itxtadd31:			;Dbut de la fonction de comparaisons successives.
 inc h					;v
 add a,31				;v
 jr z,itxtcodelettrepop ;v
itxtsub08b:				;v
 inc b					;v
 inc b					;v
itxtsub08:				;v
 inc h					;v
 sub 8					;v
 jr z,itxtcodelettrepop	;v
 djnz itxtsub08			;v
 dec l					;Mieux vaut voir le fonctionnement global de la
 ret p					;routine pour comprendre cette partie.

itxtcodelettrepop:
 pop af					;Sert  sortir de la pile l'adresse mise par "call itxtadd31",
 inc l					;car celle-ci n'a pas t sortie par le "ret p".
 jr z,itxtcapture		;Signifie que la touche presse par l'utilisateur n'tait pas une lettre.

itxtcodelettre:
 ld a,h					;Charge dans a un code relatif au nombre d'itrations de la boucle de dtection.
 or a					;Le compare  zro.
 ld a,$20				;
 jr z,itxtcopie			;Si h vaut zro, alors, le caractre  copier est un espace.
 rla					;ld a,$40, valeur  ajouter  h pour obtenir le code du caractre  copier.
 add a,h				;Production du code (voir character map) du caractre  copier.
itxtcopie:
 dec c					;Dcrmente le nombre de caractres maximum que l'on peut encore crire.
#IFDEF TI82
	ROM_CALL(TR_CHARPUT);Appel de la Rom_call de la TI82 qui affiche le caractre dont le code est contenu dans a en grandes lettres.
#else
	bcall(_putmap)		;Appel de la Rom_call de la TI83(+) qui affiche le caractre dont le code est contenu dans a en grandes lettres.
#endif
 ld hl,curcol			;
 inc (hl)				;Met  jour les variables currow et curcol.
 jr itxtnodel1			;Saute  la copie du caractre dans la mmoire et  la suite de la routine.

itxtdel:				;Gestion de la suppression d'un caractre.
 ld (de),a				;Copie zro (symbole de fin de la chane de caractres)  l'adresse pointe par de.
 dec de					;Fait pointer de vers l'adresse prcdente.
 ld a,(de)				;
 or a					;Compare la valeur de la donne qui est stoche  l'adresse susdite avec zro.
 jr z,itxtnodel			;S'il s'agit d'un zro, c'est que l'on se trouve au dbut de la chane de caractres, on ne met donc pas 
						;jour c et on incrmente  nouveau de.
 xor a					;
 ld (de),a				;Sinon, on supprime l'octet point par de.
 ld hl,curcol			;
 dec (hl)				;Dcrmente curcol afin de prparer la copie d'un espace  la place du caractre antrieur.
 ld a,$20				;Charge le code relatif  l'espace dans l'accumulateur.
#IFDEF TI82
	ROM_CALL(TR_CHARPUT);Appel de la Rom_call de la TI82 qui affiche le caractre dont le code est contenu dans a en grandes lettres.
#else
	bcall(_putmap)		;Appel de la Rom_call de la TI83(+) qui affiche le caractre dont le code est contenu dans a en grandes lettres.
#endif
 inc c					;Met  jour le compteur du nombre maximum de caractres restants.
 jr itxtcapture			;On retourne au dbut de la routine.
 
 
 
 
;Routine waitkey de Dan Weiss. 
waitkey:
   ei
WKA_loop:
   HALT
   bcall(_getcsc)
   or a
   jr z, WKA_loop
   ret



.end